/* send , sends a file to various computers */





#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <sys/un.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <netinet/in.h>

#include "lab3machines.c"


#define IN_PORT 30000 /* port the deamon listens to */
#define OUT_PORT 30001 /* port that the client is expecting the data to be returned to */


struct hostent *hp, *gethostbyname();
struct sockaddr_in sockDetail;
int fileEnded = 0;

int localFD;
char* fileNameString;
char data[4];
char codedData[7];

char tempCharacter;

/* Takes an array of 4 bytes
   Returns an array of 7 bytes that are Hamming encoded (check bytes at indices 0,1,3)
   Each byte represents the nth bits of 8 Hamming encoded 4-bit packets
*/
int hammingDecode(char* d, char* coded) {
	int i,mask=0;
	int syndrome[8];
	char c1=0, c2=0, c3=0; //check bytes


	/* copy data bytes in correctly interleaved positions */
	d[0] = coded[2];
	d[1] = coded[4];
	d[2] = coded[5];
	d[3] = coded[6];

	/* generate check bytes */
	for (i = 0; i < 8; i++) {
		syndrome[i] = 0;
		mask = (0x01 << i);

		c1 |= ((d[0]&mask)^(d[1]&mask)^(d[3]&mask));
		c2 |= ((d[0]&mask)^(d[2]&mask)^(d[3]&mask));
		c3 |= ((d[1]&mask)^(d[2]&mask)^(d[3]&mask));

		/* compare check bytes to existing check bytes */
		syndrome[i] = ((c1&mask)^((coded[0])&mask)) + ( ( (c2&mask)^((coded[1])&mask) ) << 1) + (((c3&mask)^((coded[3])&mask)) << 2);
		/* correct any detected errors */
		if (syndrome[i] != 0) {
			coded[syndrome[i]] ^= mask;
		}
	}

	return 1;
}

int main(int argc, char** argv) {
	int i;
	int numBytes;
	int sockFD[7];
	struct sockaddr_in sockBobs[7];

	if (argc > 1) fileNameString = argv[1];
	else {
		printf("Give me an output file!!!!!!!!!!!!!!!!!!!!!! \n");
		exit(0);
	}


	localFD = open(fileNameString, O_RDWR|O_CREAT);


	for(i = 0; i<7; i++){
		sockFD[i] = socket(PF_INET,SOCK_STREAM,0);
		if(sockFD[i] < 0) {
			printf("Error opening socket %d, quitting\n", i);
			exit(0);
		}

 		hp = gethostbyname(daemons[i]);
		if (hp == 0) {
          		printf("%s: unknown host\n", argv[1]);
          		exit(2);
     		}

		bcopy(hp->h_addr, &sockBobs[i].sin_addr, hp->h_length);

  		sockBobs[i].sin_family = PF_INET;

		sockBobs[i].sin_port = htons(OUT_PORT);

		connect(sockFD[i], (struct sockaddr *)&sockBobs[i], sizeof(sockBobs[i]));


	}



	/* read the code from the computers and then decode. then output ot a file */

	while (!fileEnded) {

		for(i=0;i<7;i++){

			read(sockFD[i], &codedData[i],1);
			if(codedData[i] == EOF){
				fileEnded = 1;
			}
		}

		hammingDecode( data, codedData);

		write(localFD,data,4);




	}


	return 666;
}

